//章节ID
var _sectionId = 0;
var HexStudy = H.using("hexstudy");
var underLine = new HexStudy.UnderLine();
//设备类型
underLine.system = "mobile";

var getBookReadFunName = function(funs) {
    var rval="";
    funs=funs.replace("{","\r\n{");
    var i,firstline;
    i=funs.indexOf("\r\n");
    if(i>-1)
        firstline=funs.substring(0,i);
    else
        firstline=funs;
    rval=firstline.replace("function","");
    i=rval.indexOf("(");
    if(i>-1)
        rval=rval.substring(0,i);
    rval=rval.replace(new RegExp(" ","g"),"");
    if(rval=="")rval=firstline;
    return rval;
}

/*设置章节ID*/
var setSectionIdHandler = function(data) {
    if (data != null) {
        _sectionId = data.sectionId;
    }
}

/*夜间模式*/
var setBlackStely = function() {
    try {
        $('img').css({
            opacity: 0.5
        });
        $('html,body').css({
            background: 'black',
            color: 'rgba(255,255,255,.5)'
        });
        $('.heading1, .heading2, .heading3, .paragraph1, .paragraph2, .paragraph3').css({
            color: 'rgba(255,255,255,.5)'
        });
    } catch(e) {

    }
}

/*删除夜间模式模式*/
var setRemoveBlackStely = function() {
    try {
        $('html, body, img').removeAttr('style');
        $('.heading1, .heading2, .heading3, .paragraph1, .paragraph2, .paragraph3').removeAttr('style');
    } catch(e) {

    }
}

/*获取body高度*/
var getBodyHeight = function(data) {
    var responseData = {};
    responseData["outerHeight"] = $("body").outerHeight(true);
    responseData["outerWidth"] = $("body").outerWidth(true);
    if (data != null) responseData["sectionId"] = data.sectionId;
    window.kanghaitao.listenHeightMessage(data.sectionId, $("body").outerHeight(true));
}

/*设置body边距*/
var setBodyMargin = function(data) {
    var responseData = {};
    try {
        //调整body上、下、左、右边距
        var margin = $("body").outerWidth(true) * 0.03;
        var bodyObj = document.getElementsByTagName("body");
        bodyObj[0].setAttribute("topmargin", margin);
        bodyObj[0].setAttribute("rightmargin", margin * 2);
        bodyObj[0].setAttribute("bottommargin", margin);
        bodyObj[0].setAttribute("leftmargin", margin * 2);
        bodyObj[0].setAttribute("onmousewheel", "return false");
        //bodyObj[0].setAttribute("margin", margin);
        responseData["status"] = true;
        //responseCallback(responseData);
    } catch(e) {
        responseData["status"] = false;
        responseData["excption"] = e;
        //responseCallback(responseData);
    }
}

/*为正文中课件绑定事件*/
$('courseware').unbind('click').click(function(e) {
    try {
        var responseData = {};
        responseData["id"] = $(this).attr('id');
        responseData["cwurl"] = $(this).attr('cwurl');
        responseData["cwtype"] = $(this).attr('cwtype');
        responseData["cwshowmodel"] = $(this).attr('cwshowmodel');
        responseData["status"] = true;
        window.kanghaitao.coursewareCallback(_sectionId, JSON.stringify(responseData));
    } catch(e) {

    }
});

/*获取页面内页码列表*/
var getPageNumberList = function() {
    var pageList = underLine.InitPage();
    if (pageList.length > 0) {
        window.kanghaitao.pageNumberListCallback(_sectionId, JSON.stringify(pageList));
    }
}

/*获取知识点列表*/
var getKeyPointList = function() {
    try {
        var keyPointList = underLine.InitKeyPoint2();
        if (keyPointList.length > 0) {
            window.kanghaitao.keyPointListCallback(_sectionId, JSON.stringify(keyPointList));
        }
    } catch(e) {}
}

/*划重点黄色：ffce54  红色：f47474*/
var drawEmphasisHandler = function() {
    var responseData = {};
    try {
        var sel = window.getSelection();
        sel.removeAllRanges();
        sel.addRange(kang_selection_range);

        var emphasisNoteList = underLine.Draw();
        if (emphasisNoteList.length > 0) {
            responseData["status"] = true;
            responseData["sectionId"] = _sectionId;
            responseData["emphasisNoteList"] = emphasisNoteList;
        } else {
            responseData["status"] = false;
        }
        window.kanghaitao.drawEmphasisCallback(_sectionId, JSON.stringify(responseData));
    } catch(e) {
        responseData["status"] = false;
        responseData["excption"] = e;
        window.kanghaitao.drawEmphasisCallback(_sectionId, JSON.stringify(responseData));
    }
}

/*划笔记*/
var drawEmphasisNoteHandler = function() {
    var responseData = {};
    try {
        //android.selection.clearSelection();
        var emphasisNoteList = underLine.Draw();
        if (emphasisNoteList.length > 0) {
            responseData["status"] = true;
            responseData["sectionId"] = _sectionId;
            var emphasisNoteIndex = 0;
            var range = underLine.getRangeByPosition(emphasisNoteList[emphasisNoteIndex].Start, emphasisNoteList[emphasisNoteIndex].End, emphasisNoteList[emphasisNoteIndex].HexID);
            var data = underLine.sendRangeData(range, emphasisNoteList[emphasisNoteIndex]);
            emphasisNoteList[0].Rect = data.Rects[0];
            responseData["emphasisNoteList"] = emphasisNoteList;
        } else {
            responseData["status"] = false;
        }
        window.kanghaitao.drawEmphasisNoteCallback(_sectionId, JSON.stringify(responseData));
    } catch(e) {
        responseData["status"] = false;
        responseData["excption"] = e;
        window.kanghaitao.drawEmphasisNoteCallback(_sectionId, JSON.stringify(responseData));
    }
}

/*删除重点*/
var removeEmphasisHandler = function(data) {
    var responseData = {};
    try {
        $('[relation="' + data.Relation + '"]').remove();
        responseData["status"] = true;
        responseData["sectionId"] = _sectionId;
        window.kanghaitao.removeEmphasisResultCallback(_sectionId, JSON.stringify(responseData));
    } catch(e) {
        responseData["status"] = false;
        responseData["excption"] = e;
        window.kanghaitao.removeEmphasisResultCallback(_sectionId, JSON.stringify(responseData));
    }
}

/*初始化加载重点*/
var initEmphasisHandler = function(data) {
    var responseData = {};
    try {
        drawEmphasisNote(data, true);
        responseData["status"] = true;
        window.kanghaitao.initEmphasisCallback(_sectionId, JSON.stringify(responseData));
    } catch(e) {
        responseData["status"] = false;
        responseData["errorMssage"] = e.message;
        window.kanghaitao.initEmphasisCallback(_sectionId, JSON.stringify(responseData));
    }
}

/*渲染重点*/
var renderEmphasisNoteHandler = function(data) {
    var responseData = {};
    try {
        window.getSelection ? window.getSelection().removeAllRanges() : document.selection.empty();
        drawEmphasisNote(data, false);
        //window.getSelection().removeAllRanges();
        window.getSelection ? window.getSelection().removeAllRanges() : document.selection.empty();
        responseData["status"] = true;
        window.kanghaitao.renderEmphasisNoteCallback(_sectionId, JSON.stringify(responseData));
    } catch(e) {
        responseData["status"] = false;
        responseData["errorMssage"] = e.message;
        window.kanghaitao.renderEmphasisNoteCallback(_sectionId, JSON.stringify(responseData));
    }
}

//渲染重点
var drawEmphasisNote = function(emphasisNoteList, comStatus) {
    for (var emphasisNoteIndex in emphasisNoteList) {
        try {
            var range = underLine.getRangeByPosition(emphasisNoteList[emphasisNoteIndex].Start, emphasisNoteList[emphasisNoteIndex].End, emphasisNoteList[emphasisNoteIndex].HexID);
            var data = underLine.sendRangeData(range, emphasisNoteList[emphasisNoteIndex]);
            var display = "";//data.Teacher ? "display:none" : "";
            var note = data.Note ? "true" : "false";
            var teacher = data.Teacher ? "hex-teacher" : "hex-student";
            var css = teacher + " js-underline";
            var styleColor = data.Teacher ? "opacity: 0.2;background-color: #f47474;" : "opacity: 0.2;background-color: #ffce54;";
            if (note == "true" && comStatus) { //comStatus true标示初始化渲染,else oc独立调用渲染
                //通知OC JAVA
                window.kanghaitao.initShowNoteCallback(_sectionId, JSON.stringify(data));
            }
            $.each(data.Rects,
                function () {
                    //渲染划重点
                    var newDiv = $('<div class="' + css + '" top="' + this.top + '" key="' + data.Key + '" hexid="' + data.HexID + '" relation="' + data.Relation + '" note="' + note + '" style="' + styleColor + 'position:absolute;top:' + this.top + 'px;left:' + this.left + 'px;height:' + this.height + 'px;width: ' + this.width + 'px;' + display + '"></div>');
                    $(document.body).append(newDiv);
                });
        } catch (e) {

        }
    }

    //重点操作菜单显示事件
    $('.js-underline.hex-student').unbind('click').click(function (e) {
        try {
            e.stopPropagation();
            var responseData = {};
            var relationId = $(this).attr("relation");
            //var relationSplit = relationId.split("&");
            //var hexId = relationSplit[1];
            var relationList = $('[relation="' + relationId + '"]');
            for (var hexObj in relationList) {
                if (relationId.indexOf($(relationList[hexObj]).attr("hexid")) > 0) {
                    responseData["top"] = $(relationList[hexObj]).attr("top");
                    responseData["HexId"] = $(relationList[hexObj]).attr("hexid");
                    break;
                }
            }
            responseData["sectionId"] = _sectionId;
            responseData["Relation"] = relationId;
            responseData["note"] = $(this).attr("note");
            responseData["mousePos"] = mousePos(e);
            responseData["status"] = true;
            window.kanghaitao.removeEmphasisCallback(_sectionId, JSON.stringify(responseData));
        } catch (e) {
            responseData["status"] = false;
            responseData["excption"] = e;
        }
    });
}

//鼠标位置
var mousePos = function(e) {
    var x, y;
    var e = e || window.event;
    return {
        x: e.clientX + document.body.scrollLeft + document.documentElement.scrollLeft,
        y: e.clientY + document.body.scrollTop + document.documentElement.scrollTop
    };
};

/*停止和播放网页上的视频：iPad上在网页里播放视频，即使关掉webView，依旧余音绕耳，调用下面的js可以停止播放*/
var stopVideo = function() {
    var responseData = {};
    try {
        var videos = document.querySelectorAll("video");
        for (var i = videos.length - 1; i >= 0; i--) {
            videos.pause();
        }
        responseData["stop"] = true;
        responseCallback(JSON.stringify(responseData));
    } catch(e) {
        responseData["stop"] = false;
        responseData["excption"] = e;
        responseCallback(JSON.stringify(responseData));
    }
}

/*注册字号放大事件*/
var setFontSizeHandler = function(data) {
    var responseData = {};
    var fontSize = "14px";
    var number = data.currentFontSize;
    switch (number) {
        case - 2 : $('body').css({
            'font-size': '10px'
        });
            break;
        case - 1 : $('body').css({
            'font-size': '12px'
        });
            break;
        case 1:
            $('body').css({
                'font-size':
                    '16px'
            });
            break;
        case 2:
            $('body').css({
                'font-size':
                    '18px'
            });
            break;
        case 3:
            $('body').css({
                'font-size':
                    '20px'
            });
            break;
        case 4:
            $('body').css({
                'font-size':
                    '22px'
            });
            break;
        case 5:
            $('body').css({
                'font-size':
                    '24px'
            });
            break;
        case 6:
            $('body').css({
                'font-size':
                    '26px'
            });
            break;
        case 7:
            $('body').css({
                'font-size':
                    '28px'
            });
            break;
        case 8:
            $('body').css({
                'font-size':
                    '30px'
            });
            break;
        case 0:
        default:
            $('body').css({
                'font-size':
                    '14px'
            });
            break;
    }
    responseData["fontSize"] = number;
    responseData["status"] = true;
    responseData["sectionId"] = data.sectionId;
    window.kanghaitao.setFontSizeCallback(_sectionId, JSON.stringify(responseData));
}
location.href = "###";