
/*
 划重点
 */


(function (H) {

    H.namespace("hexstudy", function (ns) {



        ns.UnderLine = H.Class(function () {

            var that = this;

//            this.pageContainerId = "pagecontent";
            this.pageContainer = document.body;//document.getElementById(that.pageContainerId);

            this.drawing=false;
            this.underLineList = [];
            this.positionList = [];
            this.HexStudyModel = H.using("hexstudy.model");

            /*
             system:web    浏览器访问
             system:mobile 移动端访问
             */
            this.system = "web";

            this._construct = function(){

                that = this;
            };

            this.Init = function(){

                that.InitKeyPoint();

                that.InitPage();
            };

            /* ---------------------------------  接口方法  --------------------------------- */
            this.Draw = function(e){

                var range = that._loadRange();

                if(range.collapsed){
                    return;
                }

                var listRange = that._buildRangeList(range);
                var msg = new that.HexStudyModel.MsgModel();
                var tempArray = [];

                for (var i = 0; i <= listRange.length -1; i++) {

                    var u = that._createPositionByRange(listRange[i]);

                    var m = new that.HexStudyModel.UnderLineModel();
                    m.Start = u.start;
                    m.End = u.end;
                    m.Content = u.content;
                    m.HexID = u.hexid;
                    m.Relation = tempArray.length > 0 ? tempArray[0].Relation : that.HexGuid() + "&" + u.hexid;
                    if(that.system != "web") {
                        m.Key = that.HexGuid();
                    }
                    tempArray.push(m);
                };
                if(that.system === "web"){
                    //如果是移动则不需要执行此代码，移动端报错
                    msg.Operation = "show";
                    msg.Pos = that.mousePos(e);
                    msg.UnderLineModel = tempArray;
                    window.parent.postMessage(msg, "*");

                }else{
                    return tempArray;
                }

            };

            this.mousePos = function (e) {
                var x, y;
                var e = e || window.event;
                return {
                    x: e.clientX + document.body.scrollLeft + document.documentElement.scrollLeft,
                    y: e.clientY + document.body.scrollTop + document.documentElement.scrollTop
                };
            };

            this.sendRangeData = function (range, underLineModel) {
                if (range == null || typeof  range !== "object") return;
                var msg = new that.HexStudyModel.UnderLineModel();
                msg.Key = underLineModel.Key;
                msg.Operation = "randerunderline";
                msg.Note = underLineModel.Note;
                msg.Teacher = underLineModel.Teacher;
                msg.Fontsize = parseInt($(range.commonAncestorContainer).parents("[hexid]").css("font-size"))||parseInt($(range.commonAncestorContainer).css("font-size"));


                msg.HexID = underLineModel.HexID;
                msg.Relation = underLineModel.Relation;

                var objRectList = range.getClientRects();
                var rects = new Array();
                $.each(objRectList, function() {
                    var rect = new that.HexStudyModel.RectModel();
                    rect.top = this.top + $(document).scrollTop();
                    rect.left = this.left;
                    rect.height = this.height;
                    rect.width = this.width;
                    rects.push(rect);
                });
                msg.Rects = rects;
                if(that.system === "web"){
                    window.parent.postMessage(msg, "*");
                }else{
                    return msg;
                }
            };


            this.WarpTest = function(){

                if(that.positionList && that.positionList.length > 0){

                    for(var item in that.positionList){

                        var range = this.getRangeByPosition(that.positionList[item].start, that.positionList[item].end, that.positionList[item].hexid);

                        console.log(range.startOffset);
                    }
                }

            };

            /* ---------------------------------  私有方法  --------------------------------- */
            this._loadRange = function () {

                if (!that._isSupport()) {
                    alert("该浏览器不支持划重点等功能，请升级浏览器！IE需要在IE9以上！");
                    return;
                }
                var userSelection, rangeObject;
                if (window.getSelection) {
                    //现代浏览器
                    userSelection = window.getSelection();
                } else if (document.selection) {
                    alert("其他浏览器");
                    //IE浏览器 考虑到Opera，应该放在后面
                    userSelection = document.selection.createRange();
                }
                else {
                    alert("其他");
                }
                //Range对象
                rangeObject = userSelection;

                if (userSelection.getRangeAt) {
                    //现代浏览器
                    rangeObject = kang_selection_range;//userSelection.getRangeAt(0);
                }

                if (!that._isInPageContent(rangeObject.startContainer) || !that._isInPageContent(rangeObject.endContainer)) {
                    return;
                }
                return rangeObject;
            };

            //对浏览器支持
            this._isSupport = function () {
                if (document.implementation && document.implementation.hasFeature && document.implementation.hasFeature("Range", "2.0")) {
                    return true;
                } else {
                    return false;
                }
            };

            this._isInPageContent = function (node) {
                if (that._findParent(node) == null) {
                    alert("选择的区域超出书页的范围！");
                    return false;
                }
                return true;
            };

            this._findParent = function (node) {
                if (node.parentNode != undefined && node.parentNode == that.pageContainer) {
                    return node.parentNode;
                } else if (node.parentNode != undefined) {
                    return that._findParent(node.parentNode);
                } else {
                    return null;
                }
            };


            this.getNodeByHexId = function(hexid){

                return $("[hexid='"+hexid+"']")[0];
            };

            //递归查询hexid.
            this.getHexIDByNode = function(node){

                if(node.nodeType === Node.ELEMENT_NODE){

                }

                if(node.nodeType === Node.TEXT_NODE){
                    node = node.parentNode;
                }

                var hexid = node.getAttribute("hexid");

                if(hexid){

                    return hexid;
                }

                if (node.parentNode == that.pageContainer) {
                    return "";
                }

                var parentNode = node.parentNode;

                return hexid == null ? that.getHexIDByNode(parentNode) : "";
            };

            this._exclude = function(r){

                if(r.isPointInRange(document.getElementsByTagName("img"), 1)){

                    console.log("img is not valid");

                }else{

                    console.log("ok");
                }
            };

            this.HexGuid = function(){

                var S4 = function () {
                    return (((1 + Math.random()) * 0x10000) | 0).toString(16).substring(1);
                };

                return (S4() + S4() + S4() + S4() + S4() + S4() + S4() + S4());
            };

            var ERange = function (startContainer, startOffset, endContainer, endOffset) {
                this.StartContainer = startContainer;
                this.StartOffset = startOffset;
                this.EndContainer = endContainer;
                this.EndOffset = endOffset;
                this.Start = false;
                this.End = false;
                this.StartPosition;
                this.EndPosition;
            };

            var ENode = function (node, range) {
                this.init(node, range);
            };

            ENode.prototype = {

                init: function (node, range) {
                    this.Node = node;
                    this.Range = range;
                },
                parent: function () {
                    if (this.Node.parentNode == that.pageContainer) {
                        return null;
                    }
                    var node = this.Node.parentNode;

                    if(node.getAttribute("hexid")){
                        return null;
                    }

                    return node ? new ENode(node, this.Range) : null;
                },
                children: function () {
                    var list = [], child = this.Node.firstChild;
                    while (child) {
                        list.push(new ENode(child, this.Range));
                        child = child.nextSibling;
                    }
                    return list;
                },
                index: function () {
                    var i = -1, sibling = this.Node;
                    while (sibling) {
                        i++;
                        sibling = sibling.previousSibling;
                    }
                    return i;
                },
                buildStartPosition: function () {
                    var pos = this.index();
                    if (this.Range.StartPosition != undefined) {
                        this.Range.StartPosition = pos + "," + this.Range.StartPosition;
                    } else {
                        this.Range.StartPosition = pos + "," + this.Range.StartOffset;
                    }

                    var parentNode = this.parent();

                    if (parentNode != null) {
                        parentNode.buildStartPosition();
                    }
                },
                buildEndPosition: function () {
                    var pos = this.index();
                    if (this.Range.EndPosition != undefined) {
                        this.Range.EndPosition = pos + "," + this.Range.EndPosition;
                    } else {
                        this.Range.EndPosition = pos + "," + this.Range.EndOffset;
                    }
                    if (this.parent() != null) {
                        this.parent().buildEndPosition();
                    }
                }
            };



            /* ---------------------------------   划重点  --------------------------------- */

            //获取坐标  [{"pid":123, "start":"1,23,0","end":"34,5"},{"pid":3, "start":"1,2,3,0","end":"4,5"}]
            this._createPositionByRange = function(range){

                var erange = new ERange(range.startContainer, range.startOffset, range.endContainer, range.endOffset);
                var startNode = new ENode(range.startContainer, erange);
                startNode.buildStartPosition();
                var startPosition = startNode.Range.StartPosition;


                var endNode = new ENode(range.endContainer, erange);
                endNode.buildEndPosition();
                var endPosition = endNode.Range.EndPosition;


                var u = new that.HexStudyModel.UnderLineInfo();
                u.hexid = that.getHexIDByNode(range.startContainer);
                u.start = startPosition;
                u.end = endPosition;
                u.content = range.toString();

                return u;
            };

            //根据用户选择，拆分range.
            this._countParagraphHexID = function(range){

                var hexids = [],
                    cloneContent = range.cloneContents(),
                    count = $(cloneContent).children().length; // cloneContent.children.length;//获取子元素数量，不递归。

                for (var i = 0; i <= count - 1; i++) {

                    var node = $(cloneContent).children()[i];

                    var hexid = node.getAttribute("hexid");

                    hexids.push(hexid);
                };

                return hexids;
            };

            //range: 用户选择构造range。
            this._buildRangeList = function(range){

                var hexids = that._countParagraphHexID(range),
                    rangeList = [];

                if(hexids === undefined || hexids.length <= 0){

                    rangeList.push(range);
                    return rangeList;
                }

                //没有跨段
                if(that.getHexIDByNode (range.startContainer) === that.getHexIDByNode(range.endContainer)){

                    rangeList.push(range);
                    return rangeList;
                }

                //如果跨段落，则拆分range为段落一个range
                for (var i = 0; i <= hexids.length - 1; i++) {

                    var hexid = hexids[i],
                        currentRange = document.createRange();

                    if(hexid === that.getHexIDByNode(range.startContainer.parentNode)){

                        currentRange.setStart(range.startContainer, range.startOffset);
                        currentRange.setEnd(range.startContainer, range.startContainer.length - 1);
                        rangeList.push(currentRange);

                    }else if(hexid === that.getHexIDByNode(range.endContainer.parentNode)){


                        var node = that.getNodeByHexId(hexid);

                        var firstNode = node.firstChild;

                        currentRange.setStart(firstNode, 0);
                        currentRange.setEnd(range.endContainer, range.endOffset);
                        rangeList.push(currentRange);

                    }else{

                        var node = that.getNodeByHexId(hexid);

                        var firstNode = node.firstChild,
                            lastNode = that.getLastNode(node),
                            length = lastNode.nodeType === Node.TEXT_NODE ? lastNode.length : 0;

                        currentRange.setStart(firstNode, 0);
                        currentRange.setEnd(lastNode, length);
                        rangeList.push(currentRange);
                    }

                };

                return rangeList;
            };


            //根据长度－创建rangeOffset.
            this.getLastNode = function(node){

                if(node.nodeType === Node.TEXT_NODE){

                    return node;
                }


                var nodeLast = node.childNodes[node.childNodes.length - 1];


                if(nodeLast.nodeType === Node.TEXT_NODE){

                    return nodeLast;
                }

                if(nodeLast.childNodes.length>0){

                    return that.getLastNode(nodeLast);
                }

                return nodeLast;
            };

            //需要段落id
            this.buildRangeByPosition = function(start, end, hexid){

                var startPosArray = start.split(",");
                var endPosArray = end.split(",");
                var oRange = document.createRange();

                var pageContainer = that.getNodeByHexId(hexid);
                var startNode = pageContainer.firstChild;
                for (var i = 0; i < (startPosArray.length - 1) ; i++) {
                    startNode = that._FindeSubNode(startNode, startPosArray[i]);
                    if (startNode.hasChildNodes()) {
                        startNode = startNode.firstChild;
                    }
                }
                var endNode = pageContainer.firstChild;
                for (var j = 0; j < (endPosArray.length - 1) ; j++) {
                    endNode = that._FindeSubNode(endNode, endPosArray[j]);
                    if (endNode.hasChildNodes()) {
                        endNode = endNode.firstChild;
                    }
                }

                if (startNode.nodeName == "IMG") {
                    oRange.setStart(startNode, 0);
                } else {
                    oRange.setStart(startNode, startPosArray[startPosArray.length - 1]);
                }

                if (endNode.nodeName == "IMG") {
                    oRange.setStart(endNode, 0);
                } else {
                    oRange.setEnd(endNode, endPosArray[endPosArray.length - 1]);
                }
                return oRange;

            };

            //???
            this.InitUnderLine = function () {

                that.underLineList.forEach(function (item) {
                    var range = that.getRangeByPosition(item.Start, item.End, item.HexID);
                    that.sendRangeData(range, item);
                });
            };


            /* ---------------------------------   初始化划重点  --------------------------------- */

            //获取range  nodeStartPosition：'1,0,47'.
            this.getRangeByPosition = function (nodeStartPosition, nodeEndPosition, hexid) {
                var startPosArray = nodeStartPosition.split(",");
                var endPosArray = nodeEndPosition.split(",");
                var oRange = document.createRange();
                var pageContainer = that.getNodeByHexId(hexid);
                var startNode = pageContainer.firstChild;


                for (var i = 0; i < (startPosArray.length - 1) ; i++) {
                    startNode = that._FindeSubNode(startNode, startPosArray[i]);
                    if (startNode.hasChildNodes()) {
                        startNode = startNode.firstChild;
                    }
                }

                var endNode = pageContainer.firstChild;
                for (var j = 0; j < (endPosArray.length - 1) ; j++) {
                    endNode = that._FindeSubNode(endNode, endPosArray[j]);
                    if (endNode.hasChildNodes()) {
                        endNode = endNode.firstChild;
                    }
                }

                if (startNode.nodeName == "IMG") {
                    oRange.setStart(startNode, 0);
                } else {
                    oRange.setStart(startNode, startPosArray[startPosArray.length - 1]);
                }

                if (endNode.nodeName == "IMG") {
                    oRange.setStart(endNode, 0);
                } else {
                    oRange.setEnd(endNode, endPosArray[endPosArray.length - 1]);
                }
                return oRange;
            };

            this._FindeSubNode = function (firstNode, len) {
                var next = firstNode;
                for (var i = 0; i < len; i++) {
                    next = next.nextSibling;
                }
                return next;
            };


            /* ---------------------------------   事件监听  --------------------------------- */
            this.displayMessage = function(evt) {
                var message;
                if (false) {
                    message = "当前提交数据被禁止！来源非法";
                    alert(message);
                } else {
                    if (evt.data.Operation == "init") {
                        if (evt.data.SourceType == "underline") {
                            //underLine.key = evt.data.Key;
                            that.underLineList = evt.data.SourceLib;
                            that.InitUnderLine();
                        } else {
                            underLine.keyPointLib = evt.data.SourceLib;
                            underLine.InitKeyPoint();
                        }
                    } else if (evt.data.Operation == "scroll") {
                        var tmp = $('#pagecontent p').first()[0];
                        $('#pagecontent p').each(function (k, v) {
                            //console.log("offsetTop:" + v.offsetTop + "       offsetHeight" + v.offsetHeight);
                            if (v.offsetTop <= evt.data.ScrollTop) {
                                tmp = v;
                            }
                        });

                        evt.source.scrollCallback(tmp.id);
                        //添加重点笔记成功
                    }else if (evt.data.Operation == "add") {
                        that.addSuccess(evt.data.UnderLineModel);
                    }else if (evt.data.Operation == "del") {
                        underLine.delSuccess(evt.data.Key);
                    } else if (evt.data.Operation == "updateunderlineobj") {
                        underLine.updateUnderlineObj(evt.data.UnderLineObj);
                    }
                }
            };

            this.addSuccess = function (underLineModel) {

                for(var i=0;i<underLineModel.length;i++){

                    var c = underLineModel[i];

                    that.underLineList.push(c);
                    that.sendRangeData(that.getRangeByPosition(c.Start, c.End, c.HexID), c);
                    window.getSelection ? window.getSelection().addSuccess : document.selection.empty();

                }

            };


            /* ---------------------------------   知识点/原书页码  --------------------------------- */
            this.setKeyPoint = function (range, key) {
                var objRectList = range.getClientRects();
                var msg = new that.HexStudyModel.MsgModel();
                msg.Key = key;
                msg.Operation = "randerkeypoint";
                var rects = [];

                $.each(objRectList, function () {
                    var rect = new that.HexStudyModel.RectModel();
                    rect.top = this.top + $(document).scrollTop();
                    rect.left = this.left;
                    rect.height = this.height;
                    rect.width = this.width;
                    rects.push(rect);
                });

                msg.Rects = rects;

                if(that.system === "mobile"){

                    return msg;

                }else{
                    window.parent.postMessage(msg, "*");
                }

            };

            this.InitKeyPoint = function () {
                var keyPointListObj = new Array();
                $('p[keypoint]').each(function (k, v) {
                    var range = that.getRangeByPosition($(v).attr("keypoint"), $(v).attr("keypoint"), $(v).attr("hexid"));
                    var pointkey = $(v).attr('keypoint-key');
                    var result = that.setKeyPoint(range, pointkey);
                    keyPointListObj.push(result);
                });
                return keyPointListObj;
            };

            this.setKeyPoint2 = function (range, key, text) {
                var objRectList = range.getClientRects();
                var msg = new that.HexStudyModel.MsgModel();
                msg.Key = key == null ? me.key : key;
                msg.Operation = "randerkeypoint";
                msg.Text = text;
                msg.Fontsize = parseInt($(range.commonAncestorContainer).parents("[hexid]").css("font-size"))||parseInt($(range.commonAncestorContainer).css("font-size"));
                var rects = new Array();
                $.each(objRectList, function () {
                    var rect = new that.HexStudyModel.RectModel();
                    rect.top = this.top + $(document).scrollTop();
                    rect.left = this.left;
                    rect.height = this.height;
                    rect.width = this.width;
                    rects.push(rect);
                });
                msg.Rects = rects;
                if(that.system === "mobile"){
                    if (rects.length > 0)
                        return msg;
                    else
                        return null;
                }else{
                    window.parent.postMessage(msg, "*");
                }
            };

            this.InitKeyPoint2 = function () {
                var keyPointListObj = new Array();
                $('p[page]').each(function () {
                    var range = document.createRange();
                    range.setStart(this, 0);
                    range.setEnd(this, 1);
                    var result = that.setKeyPoint2(range, $(this).attr("hexid"), $(this).attr("keypoint-key"));
                    if (result != null)
                        keyPointListObj.push(result);
                });
                return keyPointListObj;
            };

            this.InitPage = function () {
                var pageListObj = new Array();
                $('p[page]').each(function () {
                    var range = document.createRange();
                    range.setStart(this, 0);
                    range.setEnd(this, 1);
                    var result = that.setPage(range, $(this).attr("hexid"), $(this).attr("page"));
                    if (result != null)
                        pageListObj.push(result);
                });
                return pageListObj;
            };

            this.setPage = function (range, key, text) {
                var objRectList = range.getClientRects();
                var msg = new that.HexStudyModel.MsgModel();
                msg.Key = key == null ? me.key : key;
                msg.Operation = "randerpage";
                msg.Text = text;
                msg.Fontsize = parseInt($(range.commonAncestorContainer).parents("[hexid]").css("font-size"))||parseInt($(range.commonAncestorContainer).css("font-size"));
                var rects = new Array();
                $.each(objRectList, function () {
                    var rect = new that.HexStudyModel.RectModel();
                    rect.top = this.top + $(document).scrollTop();
                    rect.left = this.left;
                    rect.height = this.height;
                    rect.width = this.width;
                    rects.push(rect);
                });
                msg.Rects = rects;
                if(that.system === "mobile"){
                    if (rects.length > 0)
                        return msg;
                    else
                        return null;
                }else{

                    window.parent.postMessage(msg, "*");
                }

            }



        }).base(null);

    });
}(HexStudy));

